/// @file
////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// Copyright (C) 2018/19      Christian Lessig, Otto-von-Guericke Universitaet Magdeburg
///
////////////////////////////////////////////////////////////////////////////////////////////////////
///
///  module     : assignment 3
///
///  author     : lessig@isg.cs.ovgu.de
///
///  project    : GPU Programming
///
///  description: CUDA basics
///
////////////////////////////////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <limits>
#include <cassert>
#include <iomanip>
#include <chrono>
#include <vector>
#include <numeric>

#include "cuda_util.h"

////////////////////////////////////////////////////////////////////////////////////////////////////
// merge using global memory
////////////////////////////////////////////////////////////////////////////////////////////////////
__global__
void
merge_device1( int* data, int* scratch , const int size, const int stride) {

  //TODO: implement merge

}

////////////////////////////////////////////////////////////////////////////////////////////////////
// merge using shared memory
////////////////////////////////////////////////////////////////////////////////////////////////////
__global__
void
merge_device2( int* data, const int size) {

  //TODO: implement merge

}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! Generate random input for mergesort
////////////////////////////////////////////////////////////////////////////////////////////////////
void
input( int*& data, int*& dataref, const int size) {

  // TODO: generate array with random integers

  // TODO: compute reference solution

}

////////////////////////////////////////////////////////////////////////////////////////////////////
// initialize Cuda device
////////////////////////////////////////////////////////////////////////////////////////////////////
void
initDevice( int& device_handle, int& max_threads_per_block) {

  //TODO
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! Global memory version
////////////////////////////////////////////////////////////////////////////////////////////////////
void
mergeSort1( const int size) {

  int* data = nullptr;
  int* dataref = nullptr;
  input( data, dataref, size);

  // TODO: compute reference solution

  // TODO: query available and set device

  // TODO: initialize device memory
  int* data_device = nullptr;
  int* scratch_device = nullptr;
  // TODO: allocate device memory

  // TODO: copy device memory

  // TODO: determine thread layout

  // TODO: run kernel merge_device1

  // TODO: copy result back to host and check correctness

  // TODO: clean up device memory

  // clean up host memory
  free( data);
}

////////////////////////////////////////////////////////////////////////////////////////////////////
//! Shared memory version
////////////////////////////////////////////////////////////////////////////////////////////////////
void
mergeSort2( const int size) {

  int* data = nullptr;
  int* dataref = nullptr;
  input( data, dataref, size);

  // TODO: compute reference solution

  // TODO: query available and set device

  // TODO: initialize device memory
  int* data_device = nullptr;
  int* scratch_device = nullptr;
  // allocate device memory

  // copy device memory

  // TODO: determine thread layout

  // TODO: run kernel merge_device2

  // TODO: run kernel merge_device1

  // TODO: copy result back to host and check correctness

  // TODO: clean up device memory

  // clean up host memory
  free( data);
}


////////////////////////////////////////////////////////////////////////////////////////////////////
// program entry point
////////////////////////////////////////////////////////////////////////////////////////////////////
int
main( int /*argc*/, char** /*argv*/ ) {

  const int n = 8192;

  mergeSort1( n);

  return EXIT_SUCCESS;
}
